<template>
  <Page>
    <ActionBar title="Your profile">
      <NavigationButton text="Go back" android.systemIcon="ic_menu_back" @tap="$navigateBack" />
    </ActionBar>
      <StackLayout>
        <Label text="Name" textWrap="true" />
        <TextField hint="First name" v-model="name" />
  
        <Label text="Surname" textWrap="true" />
        <TextField hint="Last name" v-model="surname" />
  
        <Label text="Get notifications around" textWrap="true" />
        <Slider v-model="radius" :value="user.radius"  minValue="100" maxValue="2000"/>
        <Label :text="radius" textWrap="true" />
        
        
        <Label text="Interests" textWrap="true" />
        <TextView hint="Enter your interests" v-model="interests" editable="true" />
        
        <Button text="Update your profile" @tap="updateProfile" />
        
      </StackLayout>
  </Page>
</template>

<script>
import { mapGetters } from 'vuex';

  export default {
    data() {
      return {
        name: '',
        surname: '',
        radius: 0,
        interests: ''

      }
    },
    created() {
      this.name = this.user.name
      this.surname = this.user.surname
      this.radius = this.user.radius
      this.interests = this.user.interests.join(' ')
    },
    computed: {
      ...mapGetters({user: 'getUser'})

    },
    methods: {
      updateProfile() {
        if (this.name === '' || this.surname === '') {
          alert('You must have your first name and last name entered.')
        }
        
        const error = this.$store.dispatch('updateProfile', this.$data)
        console.log('PRESENT THE ERROR');
        console.log(error)
        const hasError = Object.keys(error).length !== 0
        if (!hasError) {
          this.$navigateBack({clearHistory: true})
        } else {
          console.log('ERROR IN EDIT PROFILE')
        }
      }
    },
  }
</script>

<style scoped>

</style>